setlocal
@@echo off
Rem Usage: SemExecMain.cmd [TPCH_RUN_NUM] [TPCH_EXEC_LIST]
Rem %TPCH_EXEC_LIST% needs to contain the full path of the list
Rem %TPCH_EXEC_LIST% should be a list of .Sql files

set TPCH_RUN_NUM=%1
set TPCH_EXEC_LIST=%2
set TPCH_NUM_PARALLEL_DM_EXEC_STREAMS=%3
set TPCH_OUTPUT_DIR=%TPCH_OUTPUT_DIR_PREFIX%\%TPCH_RUN_NUM%
set TPCH_MASTERLOG_FILE=%TPCH_OUTPUT_DIR%\%TPCH_MASTERLOG_NAME%
set TPCH_EXEC_LIST_NAME=%~n2
set TPCH_EXEC_LIST_PATH=%~dp2
set TPCH_INDEXED_EXEC_LIST=%TPCH_EXEC_LIST_PATH%\Indexed%TPCH_EXEC_LIST_NAME%.txt

if not exist %TPCH_OUTPUT_DIR% md %TPCH_OUTPUT_DIR%

if not exist %TPCH_EXEC_LIST% (
		
	echo  !DATE! !TIME! %TPCH_EXEC_LIST% does not exist    
	echo  !DATE! !TIME! Script will exit         		
	echo  !DATE! !TIME! %TPCH_EXEC_LIST% does not exist    >>%TPCH_MASTERLOG_FILE%
	echo  !DATE! !TIME! Script will exit         		>>%TPCH_MASTERLOG_FILE%
	goto Exit
)

echo.>%TPCH_INDEXED_EXEC_LIST%

pushd %TPCH_OUTPUT_DIR%

set /A TPCH_EXEC_COUNT=0
Rem Get the number of execs and generate the text file used by execSQLFileList.cmd to run the actual query
For /f "tokens=1 " %%i in (%TPCH_EXEC_LIST%) do (
	set /A TPCH_EXEC_COUNT=!TPCH_EXEC_COUNT!+1
	set TPCH_CURRENT_EXEC_FILE_NAME=%%~ni
	echo !TPCH_CURRENT_EXEC_FILE_NAME!.sql>!TPCH_CURRENT_EXEC_FILE_NAME!.txt
	echo !TPCH_EXEC_COUNT!,!TPCH_CURRENT_EXEC_FILE_NAME!.sql,!TPCH_CURRENT_EXEC_FILE_NAME!.txt>>%TPCH_INDEXED_EXEC_LIST%
)

for /F "tokens=1,2,3,4 delims=:. " %%i in ( "%time%" ) do set TIME_STAMP=%%i_%%j_%%k_%%l
for /F "tokens=1,2,3,4 delims=/ " %%i in ( "%date%" ) do set DATE_STAMP=%%l_%%j_%%k

set TPCH_GLOBAL_SEMAPHORE_NAME=%TPCH_EXEC_LIST_NAME%_%DATE_STAMP%_%TIME_STAMP%_SemGateExit
set TPCH_LOCAL_SEMAPHORE_NAME=%TPCH_EXEC_LIST_NAME%_%DATE_STAMP%_%TIME_STAMP%_EvtGateExit

start %TPCH_AUTOMATION_CMD_PATH%\WaitForEvent.cmd %TPCH_LOCAL_SEMAPHORE_NAME% %TPCH_GLOBAL_SEMAPHORE_NAME%
timeout 2

 	start %TPCH_AUTOMATION_CMD_PATH%\SemExecLoop.cmd %TPCH_LOCAL_SEMAPHORE_NAME% %TPCH_RUN_NUM% %TPCH_INDEXED_EXEC_LIST% %TPCH_NUM_PARALLEL_DM_EXEC_STREAMS% !TPCH_EXEC_COUNT!

REM Wait for the gate here
call %TPCH_AUTOMATION_EXEC%\semaphore.exe -wait %TPCH_GLOBAL_SEMAPHORE_NAME% -count 1


popd

:Exit
endlocal